/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include    <iomanip>
#include    <iostream>
#include    <sstream>

using namespace std;

#define     fdRead      0
#define     fdWrite     1

int main(int argc, char** argv)
{
  unsigned char     bytes[200];
  unsigned int      data;
  unsigned int      idx;
  string            line; 

  

  while( getline(cin, line) )
  { 
      string    timestamp;
      idx   = 0;
      
      size_t  pos = line.find( ';' );
      
      if( pos != string::npos )
      {
        timestamp = line.substr( 0, pos );
        line.erase( 0, pos+1 );
      }
      
/*      cout << pos << endl;
      cout << timestamp << endl;
      cout << line << endl;*/
      
      stringstream  strm( line );
      
      while( strm >> std::hex >> data )
      {
        bytes[idx]  = data;
        idx++;
        if( idx >= sizeof(bytes) / sizeof(bytes[0]) )
        {
          return    -1;
        }
      }
      
      if( (bytes[0] & 0x80) == 0 )    // not a data packet
      {
        continue;
      }
      
      if( pos != string::npos )
      {
        cout << timestamp << "; ";
      }
      
/*      cout << setfill(' ');
      
      cout << setw(2) << hex << (bytes[0] && 0x3f);       // Destination
      cout << " ";
      cout << setw(2) << hex << (bytes[1] && 0x3f);       // Source
      cout << " ";
      cout << setw(2) << hex << (bytes[2] >> 4);           // Command
      cout << " ";
      cout << setw(2) << hex << (bytes[2] & 0x0f);     // Length
      cout << " ";*/
      
      cout << setfill('0');
      
      for( unsigned int i = 0; i < idx-2; i++ )
      {
        cout << setw(2) << hex << (int)bytes[i];
        cout << " ";
      }

      cout << endl;
  }
  
  return    0;
}

